function test_targets = cell_median_hausdorff_nn(train_patterns, train_targets, test_patterns, Knn)

% Classify using the Nearest neighbor algorithm
% Inputs:
% 	train_patterns	- Train patterns
%	train_targets	- Train targets
%   test_patterns   - Test  patterns
%	Knn		        - Number of nearest neighbors 
%
% Outputs
%	test_targets	- Predicted targets

L			= length(train_targets);
Uc          = unique(train_targets);

if (L < Knn),
   error('You specified more neighbors than there are points.')
end

N               = length(test_patterns);
test_targets    = zeros(1,N); 
for i = 1:N
    dist            = median_hausdorff_cosine_distance(train_patterns, test_patterns(1,i));
    [~, indices]    = sort(dist);
    
    n               = hist(train_targets(indices(1:Knn)), Uc);
    
    vmax = max(n);
    best = find(n==vmax);
%     best = find(n>0);
    if length(best) == 1   
        test_targets(i) = Uc(best);
    else
        dist = dist(1:Knn);
        for j = 1:length(best)
            tmp(j) = mean(dist(train_targets(indices(1:Knn))==Uc(best(j))));
        end
        [~, best_best] = min(tmp');
        test_targets(i) = Uc(best(best_best));
        clear tmp
    end
end